#include <cstdlib>
#include <string>
#include <vector>
#include "graph.hpp"

graph::graph (const int processes, const int resources) {
   num_processes = processes;
   num_resources = resources;
   matrix.x = processes + resources;
   matrix.y = matrix.x;
   // Reserve correct number of entries to minimize reallocation
   matrix.data.reserve(matrix.x);
   for (int x = 0; x < matrix.x; x++) {
      // Make a new x (vector<int>)
      matrix.data.push_back({});
      // Reserve correct number of entries
      matrix.data[x].reserve(matrix.y);
      for (int y = 0; y < matrix.y; y++) {
         // Make a new y (int)
         matrix.data[x].push_back({});
      }
   }
}

void graph::print () {
   printf("np: %d\tnr: %d\n", num_processes, num_resources);
   printf("resource_counts:\n"); for (auto e: resource_counts) printf("%d\t", e); printf("\n");
   printf("matrix:\n"); for (auto x: matrix.data) {for (auto y: x) printf("%d\t", y); printf("\n");}
}
